## riseup-vpn 0.24.10+ds1

=== Makefile ===
#########################################################################
# Multiplatform build and packaging recipes for BitmaskVPN
# (c) LEAP Encryption Access Project, 2019-2021
#########################################################################

.PHONY: all get build icon locales generate_locales clean check_qtifw HAS-qtifw relink_vendor fmt

XBUILD ?= no
RELEASE ?= no
QMAKE ?= qmake
LRELEASE ?= lrelease
SKIP_CACHECK ?= no
VENDOR_PATH ?= providers
APPNAME ?= $(shell VENDOR_PATH=${VENDOR_PATH} PROVIDER=${PROVIDER} branding/scripts/getparam appname | tail -n 1)
TARGET ?= $(shell VENDOR_PATH=${VENDOR_PATH} PROVIDER=${PROVIDER} branding/scripts/getparam binname | tail -n 1)
PROVIDER ?= $(shell grep ^'provider =' ${VENDOR_PATH}/vendor.conf | cut -d '=' -f 2 | cut -d ',' -f 1 | tr -d "[:space:]")
VERSION ?= $(shell git describe 2> /dev/null)
ifeq ($(VERSION),)
    VERSION := "unknown"
endif
WINCERTPASS ?= pass
OSXAPPPASS  ?= pass
OSXMORDORUID ?= uid

# go paths
GOPATH = $(shell go env GOPATH)
TARGET_GOLIB=lib/libgoshim.a
SOURCE_GOLIB=gui/backend.go
SOURCE_DIRS_GO = pkg cmd gui

# detect OS
UNAME = $(shell uname -s)
ifeq ($(OS), Windows_NT)
PLATFORM = windows
else
PLATFORM ?= $(shell echo ${UNAME} | awk "{print tolower(\$$0)}")
endif

QTBUILD = build/qt
INSTALLER = build/installer

# See https://stackoverflow.com/a/65120256 if you have problems validating the cert.
OSX_CERT="Apple Distribution: LEAP Encryption Access Project"

MACDEPLOYQT_OPTS = -appstore-compliant -always-overwrite -codesign="${OSX_CERT}"

ifeq ($(PLATFORM), darwin)
INST_ROOT =${INSTALLER}/packages/bitmaskvpn/data/
INST_DATA = ${INST_ROOT}/${APPNAME}.app/
else
INST_DATA = ${INSTALLER}/packages/bitmaskvpn/data/
endif

SCRIPTS = branding/scripts
TEMPLATES = branding/templates

OPENVPN_WINDOWS_INSTALLER = https://build.openvpn.net/downloads/releases/OpenVPN-2.6.6-I001-amd64.msi

ifeq ($(PLATFORM), linux)
HAS_QTIFW :=
else
HAS_QTIFW := $(shell command -v binarycreator)
endif
OPENVPN_BIN = "$(HOME)/openvpn_build/sbin/$(shell grep OPENVPN branding/thirdparty/openvpn/build_openvpn.sh | head -n 1 | cut -d = -f 2 | tr -d '"')"


#########################################################################
# go build
#########################################################################

.PHONY: allinone
allinone: clean vendor build

depends:
	-@${MAKE} depends$(UNAME)

dependsLinux:
	# install build dependencies (from branding/templates/debian/control-template)
	@sudo apt-get install -y golang make pkg-config g++ git libqt6svg6-dev qt6-tools-dev qt6-tools-dev-tools qt6-base-dev libqt6qml6 qt6-declarative-dev dh-golang libgl-dev qt6-declarative-dev-tools qt6-l10n-tools
	# install runtime dependencies (from branding/templates/debian/control-template)
	@sudo apt-get install -y libqt6core6 libqt6gui6 libqt6qml6 libqt6widgets6 libstdc++6 libqt6svg6 qml6-module-qtquick qml6-module-qtquick-controls qml6-module-qtquick-dialogs qml6-module-qtquick-layouts qml6-module-qtqml-workerscript qml6-module-qtquick-templates qml6-module-qt-labs-settings qml6-module-qtquick-window qml6-module-qt-labs-platform qml6-module-qtcore qml6-module-qt5compat-graphicaleffects openvpn policykit-1-gnome python3 iptables
	# needed to build debian package
	@sudo apt-get install -y devscripts fakeroot
	@${MAKE} -C docker deps
	@# debian needs also: snap install snapcraft --classic; snap install  multipass --beta --classic

dependsDarwin:
	@brew install git golang make qt5
	#@brew install --default-names gnu-sed
	@brew link qt5

dependsCYGWIN_NT-10.0:
	@echo
	@echo "==================================WARNING=================================="
	@echo "You need to install all dependencies manually, please see README.md!"
	@echo "==================================WARNING=================================="
	@echo

ifeq ($(PLATFORM), darwin)
EXTRA_FLAGS = MACOSX_DEPLOYMENT_TARGET=10.10 GOOS=darwin CC=clang
else
EXTRA_FLAGS =
endif

ifeq ($(PLATFORM), windows)
EXTRA_GO_LDFLAGS = "-H=windowsgui"
endif

ifeq ($(PLATFORM), windows)
PKGFILES = $(wildcard "pkg/*") # syntax err in windows with find
else
PKGFILES = $(shell find pkg -type f -name '*.go')
endif

lib/%.a: $(PKGFILES)
	@XBUILD=no CC=${CC} VENDOR_PATH=${VENDOR_PATH} CXX=${CXX} MAKE=${MAKE} AR=${AR} LD=${LD} VERSION=${VERSION} ./gui/build.sh --just-golib

# FIXME move platform detection above! no place to uname here, just use $PLATFORM
#
MINGGW =
ifeq ($(UNAME), MINGW64_NT-10.0)
MINGW = yes
endif
ifeq ($(UNAME), MINGW64_NT-10.0-19042)
MINGW = yes
endif

relink_vendor:
	@echo "============RELINK VENDOR============="
	@echo "PLATFORM: ${PLATFORM} (${UNAME})"
	@echo "VENDOR_PATH: ${VENDOR_PATH}"
	@echo "PROVIDER: ${PROVIDER}"
ifeq ($(PLATFORM), windows)
	@rm -rf providers/assets
ifeq ($(VENDOR_PATH), providers)
	@cp -r providers/${PROVIDER}/assets providers/assets || true
endif # end windows
else # not windows: linux/osx
ifeq ($(VENDOR_PATH), providers)
	@-unlink providers/assets
	@ln -s ${PROVIDER}/assets providers/assets || true
endif
endif
	@echo "============RELINK VENDOR============="

build_golib: lib/libgoshim.a

build_gui: build_golib relink_vendor
	@echo "==============BUILD GUI==============="
	@echo "TARGET: ${TARGET}"
	@echo "VENDOR_PATH: ${VENDOR_PATH}"
	@XBUILD=no CC=${CC} CXX=${CXX} MAKE=${MAKE} AR=${AR} LD=${LD} LRELEASE=${LRELEASE} TARGET=${TARGET} VENDOR_PATH=${VENDOR_PATH} APPNAME=${APPNAME} gui/build.sh --skip-golib
	@echo "============BUILD GUI================="

build: build_helper build_gui

build_helper:
ifeq ($(PLATFORM), darwin)
	# no helper needed for linux, we use polkit/bitmask-root
	# no helper needed for windows, use openvpn interective service
	@echo "=============BUILDER HELPER==========="
	@echo "PLATFORM: ${PLATFORM}"
	@echo "APPNAME: ${APPNAME}"
	@echo "VERSION: ${VERSION}"
	@echo "EXTRA_GO_LDFLAGS: ${EXTRA_GO_LDFLAGS}"
	@mkdir -p build/bin/${PLATFORM}
	@go build -o build/bin/${PLATFORM}/bitmask-helper -ldflags "-X main.AppName=${APPNAME} -X main.Version=${VERSION} ${EXTRA_GO_LDFLAGS}" ./cmd/bitmask-helper/
	@echo "===========BUILDER HELPER============="
endif

build_openvpn:
	@[ -f $(OPENVPN_BIN) ] && echo "OpenVPN already built at" $(OPENVPN_BIN) || ./branding/thirdparty/openvpn/build_openvpn.sh

dosign:
ifeq (${PLATFORM}, windows)
	"c:\windows\system32\rcedit.exe" ${QTBUILD}/release/${TARGET}.exe --set-file-version ${VERSION}
	"c:\windows\system32\rcedit.exe" ${QTBUILD}/release/${TARGET}.exe --set-product-version ${VERSION}
	"c:\windows\system32\rcedit.exe" ${QTBUILD}/release/${TARGET}.exe --set-version-string CompanyName "LEAP Encryption Access Project"
	"c:\windows\system32\rcedit.exe" ${QTBUILD}/release/${TARGET}.exe --set-version-string FileDescription "${APPNAME}"
	"c:\windows\system32\signtool.exe" sign -debug -f "z:\leap\LEAP.pfx" -p ${WINCERTPASS} ${QTBUILD}/release/${TARGET}.exe
endif

checksign:
ifeq (${PLATFORM}, windows)
ifeq (${RELEASE}, yes)
	@sigcheck.exe ${QTBUILD}/release/${TARGET}.exe
endif
endif

installer: check_qtifw checksign
	@mkdir -p ${INST_DATA}
	@cp -r ${TEMPLATES}/qtinstaller/packages ${INSTALLER}
	@cp LICENSE ${INSTALLER}/packages/bitmaskvpn/meta/LICENSE.txt
	@cp -r ${TEMPLATES}/qtinstaller/installer.pro ${INSTALLER}
	@cp -r ${TEMPLATES}/qtinstaller/config ${INSTALLER}
	@cp ${VENDOR_PATH}/assets/icon.ico ${INSTALLER}/config/installer-icon.ico
	@cp ${VENDOR_PATH}/assets/icon.icns ${INSTALLER}/config/installer-icon.icns
	@cp ${VENDOR_PATH}/assets/installer-logo.png ${INSTALLER}/config/installer-logo.png
ifeq (${PLATFORM}, darwin)
	@mkdir -p ${INST_DATA}/helper
	@VERSION=${VERSION} VENDOR_PATH=${VENDOR_PATH} ${SCRIPTS}/gen-qtinstaller osx ${INSTALLER}
	@cp "${TEMPLATES}/osx/bitmask.pf.conf" ${INST_DATA}helper/bitmask.pf.conf
	@cp "${TEMPLATES}/osx/client.up.sh" ${INST_DATA}/
	@cp "${TEMPLATES}/osx/client.down.sh" ${INST_DATA}/
	@go build -ldflags='-w -s' -o "${INST_ROOT}/post-install" "${TEMPLATES}/qtinstaller/osx-data/post-install.go"
	@[ -f $(OPENVPN_BIN) ] && echo "OpenVPN already built at" $(OPENVPN_BIN) || ./branding/thirdparty/openvpn/build_openvpn.sh
	@cp $(OPENVPN_BIN) ${INST_DATA}/openvpn.leap
	@cp build/bin/${PLATFORM}/bitmask-helper ${INST_DATA}/
ifeq (${RELEASE}, yes)
	@echo "[+] Running macdeployqt (release mode)"
	@macdeployqt ${QTBUILD}/release/${PROVIDER}-vpn.app -qmldir=gui/components ${MACDEPLOYQT_OPTS}
else
	@echo "[+] Running macdeployqt (debug mode)"
	@macdeployqt ${QTBUILD}/release/${PROVIDER}-vpn.app -qmldir=gui/components
endif
	@cp -r "${QTBUILD}/release/${TARGET}.app"/ ${INST_DATA}/
endif
ifeq (${PLATFORM}, windows)
	@wget ${OPENVPN_WINDOWS_INSTALLER} -O ${INST_DATA}/openvpn-installer.msi
	@VERSION=${VERSION} VENDOR_PATH=${VENDOR_PATH} ${SCRIPTS}/gen-qtinstaller windows ${INSTALLER}
ifeq (${VENDOR_PATH}, providers)
	@cp ${VENDOR_PATH}/${PROVIDER}/assets/icon.ico ${INST_DATA}/icon.ico
else
	@cp ${VENDOR_PATH}/assets/icon.ico ${INST_DATA}/icon.ico
endif
	@cp ${QTBUILD}/release/${TARGET}.exe ${INST_DATA}${TARGET}.exe
ifeq (${RELEASE}, yes)
	@windeployqt --qmldir gui/components ${INST_DATA}${TARGET}.exe
else
	@windeployqt --qmldir gui/components ${INST_DATA}${TARGET}.exe
endif
	# XXX this is a workaround for missing libs after windeployqt ---
	@cp $(shell cygpath $(shell ${QMAKE} -query 'QT_INSTALL_BINS'))/libgcc_s_seh-1.dll ${INST_DATA}
	@cp $(shell cygpath $(shell ${QMAKE} -query 'QT_INSTALL_BINS'))/libstdc++-6.dll ${INST_DATA}
	@cp $(shell cygpath $(shell ${QMAKE} -query 'QT_INSTALL_BINS'))/libwinpthread-1.dll ${INST_DATA}
	@cp -r $(shell cygpath $(shell ${QMAKE} -query 'QT_INSTALL_QML')) ${INST_DATA}
endif
ifeq (${PLATFORM}, linux)
	@VERSION=${VERSION} ${SCRIPTS}/gen-qtinstaller linux ${INSTALLER}
endif
	@echo "[+] All templates, binaries and libraries copied to build/installer."
	@echo "[+] Now building the installer."
	@cd build/installer && ${QMAKE} VENDOR_PATH=${VENDOR_PATH} INSTALLER=${APPNAME}-installer-${VERSION} && ${MAKE}

sign_installer:
ifeq (${PLATFORM}, windows)
	# TODO add flag to skip signing for regular builds
	"c:\windows\system32\signtool.exe" sign -f "z:\leap\LEAP.pfx" -p ${WINCERTPASS} build/installer/${APPNAME}-installer-${VERSION}.exe
endif
ifeq (${PLATFORM}, darwin)
	gsed -i "s/com.yourcompany.installerbase/se.leap.bitmask.${TARGET}/g" build/installer/${APPNAME}-installer-${VERSION}.app/Contents/Info.plist
	codesign -s ${OSX_CERT} --options "runtime" build/installer/${APPNAME}-installer-${VERSION}.app
	ditto -ck --rsrc --sequesterRsrc build/installer/${APPNAME}-installer-${VERSION}.app build/installer/${APPNAME}-installer-${VERSION}.zip
endif

notarize_all:
	APPNAME=${APPNAME} VERSION=${VERSION} TARGET=${TARGET} OSXAPPPASS=${OSXAPPPASS} branding/scripts/osx-stapler.sh

# --------------------
# TODO test and remove

notarize_installer:
# courtesy of https://skyronic.com/2019/07/app-notarization-for-qt-applications/
ifeq (${PLATFORM}, darwin)
	xcrun altool --notarize-app -t osx -f build/installer/${APPNAME}-installer-${VERSION}.zip --primary-bundle-id="se.leap.bitmask.${TARGET}" -u "info@leap.se" -p ${OSXAPPPASS}
endif

notarize_check:
ifeq (${PLATFORM}, darwin)
	xcrun altool --notarization-info ${OSXMORDORUID} -u "info@leap.se" -p ${OSXAPPPASS}
endif

notarize_staple:
ifeq (${PLATFORM}, darwin)
	xcrun stapler staple build/installer/${APPNAME}-installer-${VERSION}.app
endif

create_dmg:
ifeq (${PLATFORM}, darwin)
	@create-dmg deploy/${APPNAME}-${VERSION}.dmg build/installer/${APPNAME}-installer-${VERSION}.app
endif
# --------------------



check_qtifw:
ifdef HAS_QTIFW
	@echo "[+] Found QTIFW"
else
	$(error "[!] Cannot find QTIFW. Please install it and add it to your PATH")
endif

clean:
	@rm -rf lib/*
	@rm -rf build/
ifeq ($(PLATFORM), windows)
	# Need to use unlink on Windows for permission reasons
	@-unlink branding/assets/default
else
	@rm -rf branding/assets/default
endif
	@cd ArchLinux && rm -rf bitmask-vpn pkg src *.tar.zst


########################################################################
# tests
#########################################################################

=== debian/changelog ===
riseup-vpn (0.24.10+ds1-1) unstable; urgency=medium

  [ Maytham Alsudany ]
  * Add -trimpath to ensure reproducible builds

  [ Nilesh Patra ]
  * New upstream version 0.24.10+ds1
  * Remove un-needed vendor code, add ginkgo as B-D
  * Re-diff patch

 -- Nilesh Patra <nilesh@debian.org>  Tue, 04 Feb 2025 23:45:46 +0530

=== debian/control ===
Source: riseup-vpn
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Nilesh Patra <nilesh@debian.org>
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any (>= 2:1.20~),
               golang-github-lucas-clemente-quic-go-dev (>= 0.46.0-2~),
               golang-github-coreos-bbolt-dev,
               golang-github-cretz-bine-dev,
               golang-github-go-openapi-errors-dev,
               golang-github-go-openapi-runtime-dev,
               golang-github-go-openapi-strfmt-dev,
               golang-github-go-openapi-swag-dev,
               golang-github-google-uuid-dev,
               golang-github-gopherjs-gopherjs-dev,
               golang-github-jtolds-gls-dev,
               golang-github-kardianos-osext-dev,
               golang-github-klauspost-cpuid-dev,
               golang-github-klauspost-reedsolomon-dev,
               golang-github-mitchellh-go-homedir-dev,
               golang-github-mmcloughlin-avo-dev,
               golang-github-onsi-ginkgo-v2-dev,
               golang-github-pion-webrtc.v3-dev,
               golang-github-pion-stun-dev (>= 0.6.1-1~),
               golang-github-pkg-errors-dev,
               golang-github-prometheus-community-pro-bing-dev,
               golang-github-protonmail-go-autostart-dev,
               golang-github-rakyll-statik-dev,
               golang-github-rs-zerolog-dev (>= 1.29.1-1~),
               golang-github-sevlyar-go-daemon-dev,
               golang-github-smartystreets-assertions-dev,
               golang-github-smartystreets-goconvey-dev,
               golang-github-stretchr-testify-dev,
               golang-github-tjfoc-gmsm-dev,
               golang-github-xtaci-kcp-dev,
               golang-github-xtaci-smux-dev,
               golang-gitlab-yawning-edwards25519-extra-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-tools-dev,
               golang-golang-x-xerrors-dev,
               golang-goptlib-dev,
               golang-snowflake-dev,
               libqt6quickcontrols2-6,
               qmake6,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-declarative-dev-tools,
               qt6-l10n-tools,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/riseup-vpn
Vcs-Git: https://salsa.debian.org/go-team/packages/riseup-vpn.git
Homepage: https://0xacab.org/leap/bitmask-vpn
Rules-Requires-Root: no
XS-Go-Import-Path: 0xacab.org/leap/bitmask-vpn

Package: riseup-vpn
Architecture: any
Depends: ca-certificates,
         iproute2,
         iptables,
         libqt6svg6,
         openvpn,
         pkexec,
         policykit-1-gnome | polkit-1-auth-agent,
         procps,
         python3:any,
         qml6-module-qt-labs-platform,
         qml6-module-qt-labs-settings,
         qml6-module-qtquick-effects,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-dialogs,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-window,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Recommends: qt6-wayland
Description: Easy, fast, and secure VPN service from riseup.net
 Riseup offers Personal VPN service for censorship circumvention,
 location anonymization and traffic encryption. To make this possible, it
 sends all user's internet traffic through an encrypted connection to
 riseup.net, where it then goes out onto the public internet.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export GOCACHE=/tmp/gocache
export DH_GOLANG_INSTALL_EXTRA=Makefile gui tests vendor/modules.txt branding providers bitmask.pro test.pro helpers pkg/pickle/helpers providers
export BUILDDIR=_build/src/0xacab.org/leap/bitmask-vpn/
export GOPATH = ${CURDIR}/_build:/usr/share/gocode
export GO111MODULE := off
export CI=1

include /usr/share/dpkg/pkg-info.mk

VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/+ds.*//' -e 's/r/\./')

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_before_dh_auto_configure:
	rm -f $(CURDIR)/pkg/motd/motd_test.go $(CURDIR)/pkg/vpn/bonafide/bonafide_test.go $(CURDIR)/pkg/vpn/bonafide/gateways_test.go

override_dh_auto_build:
	cd $(BUILDDIR) && $(MAKE) gen_providers_json PROVIDER=riseup,riseupbeta && $(MAKE) build VERSION=$(VERSION) LRELEASE=/usr/lib/qt6/bin/lrelease QMAKE=/usr/bin/qmake6 PROVIDER=riseup TARGET=riseup-vpn

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Qmake test
	cd $(BUILDDIR) && qmake6 test.pro -o tests/Makefile.test && \
	cd tests && $(MAKE) -f Makefile.test && $(MAKE) -f Makefile.test clean
	# Golang test
	DH_GOLANG_EXCLUDES=gui dh_auto_test
endif

override_dh_auto_install:
	dh_auto_install -- --no-source

## riseup-vpn 0.25.8%2Bds3

=== debian/changelog ===
riseup-vpn (0.25.8+ds3-3build1) resolute; urgency=medium

  * No-change rebuild for Qt 6.10.2.

 -- Rik Mills <rikmills@kde.org>  Sun, 22 Feb 2026 11:29:02 +0000

riseup-vpn (0.25.8+ds3-3) unstable; urgency=medium

  * Better patch for fixing Motd which does not lead to qml warnings on launch
  * Revert "Disable tests on riscv64 due to bug in go compiler" -- this is fixed
    in golang 1.24.4-4 upload (See #1114841)
  * Add patch to fixup couple of QML warnings after launching the app
  * Remove Redundant "Rules-Requires-Root: no"

 -- Nilesh Patra <nilesh@debian.org>  Sat, 18 Oct 2025 16:33:58 +0530

riseup-vpn (0.25.8+ds3-2) unstable; urgency=medium

  * Add patch to workaround progressbar not displaying with QT6.9 update
    + The work-around for progressbar and MOTD shall need to stay until
      #1118281 is fixed.
  * Add Depends on more polkits than gnome-polkit which has been removed.

 -- Nilesh Patra <nilesh@debian.org>  Sat, 18 Oct 2025 00:19:54 +0530

riseup-vpn (0.25.8+ds3-1) unstable; urgency=medium

  * Add B-D on golang-refraction-networking-utls-dev
  * Embed copy of snowflake common dir back in the package
    + snowflake package version 2.10.1 no longer vendors all the
      required files to build riseup-vpn.
  * Add patch to fix motd window with QT6.9

 -- Nilesh Patra <nilesh@debian.org>  Tue, 07 Oct 2025 23:55:39 +0530

riseup-vpn (0.25.8+ds2-2) unstable; urgency=medium

  * Add Headers to patches
  * Tweak createmanpages script and update manpages
  * Move bitmask-root manpage from section 1 to section 8
    as this is not supposed to be run manually
  * Update d/watch to version 5
  * d/salsa-ci.yml: Add provision to build also on riscv64
  * Disable tests on riscv64 due to bug in go compiler when
    packages are built with CGO_ENABLED=1

 -- Nilesh Patra <nilesh@debian.org>  Fri, 12 Sep 2025 02:03:12 +0530

riseup-vpn (0.25.8+ds2-1) unstable; urgency=medium

  * New upstream version 0.25.8+ds2 (Closes: #1097793)
  * New patch to add in missing defines in test.pro to
    fix compilation
  * Temporarily vendor quic-go until dependency bump is
    fixed upstream
    + Issue forwarded upstream with a patch
  * d/control:
    + Bump Standards-Version to 4.7.2 (no changes needed)
    + Switch to Static-Built-Using
  * d/copyright:
    + Update copyright years
    + Mention new vendored deps to d/copyright
  * Add patch to not check for updates
  * Add patch to use SOURCE_DATE_EPOCH (fixes reprotest)
  * Add patch to potentially fixup binding loop
  * Add qml6-module-qtcore to Depends (Closes: #1110558)

 -- Nilesh Patra <nilesh@debian.org>  Thu, 11 Sep 2025 02:33:40 +0530

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: riseup-vpn
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Nilesh Patra <nilesh@debian.org>
 Section: net
 Testsuite: autopkgtest-pkg-go
@@ -7,7 +8,6 @@
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any (>= 2:1.20~),
-               golang-github-lucas-clemente-quic-go-dev (>= 0.46.0-2~),
                golang-github-coreos-bbolt-dev,
                golang-github-cretz-bine-dev,
                golang-github-go-openapi-errors-dev,
@@ -28,6 +28,7 @@
                golang-github-pkg-errors-dev,
                golang-github-prometheus-community-pro-bing-dev,
                golang-github-protonmail-go-autostart-dev,
+               golang-refraction-networking-utls-dev,
                golang-github-rakyll-statik-dev,
                golang-github-rs-zerolog-dev (>= 1.29.1-1~),
                golang-github-sevlyar-go-daemon-dev,
@@ -44,7 +45,6 @@
                golang-golang-x-tools-dev,
                golang-golang-x-xerrors-dev,
                golang-goptlib-dev,
-               golang-snowflake-dev,
                libqt6quickcontrols2-6,
                qmake6,
                qt6-base-dev,
@@ -54,11 +54,10 @@
                qt6-svg-dev,
                qt6-tools-dev,
                qt6-tools-dev-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/riseup-vpn
 Vcs-Git: https://salsa.debian.org/go-team/packages/riseup-vpn.git
 Homepage: https://0xacab.org/leap/bitmask-vpn
-Rules-Requires-Root: no
 XS-Go-Import-Path: 0xacab.org/leap/bitmask-vpn
 
 Package: riseup-vpn
@@ -69,9 +68,10 @@
          libqt6svg6,
          openvpn,
          pkexec,
-         policykit-1-gnome | polkit-1-auth-agent,
+         lxpolkit | lxqt-policykit | mate-polkit | polkit-kde-agent-1 | policykit-1-gnome | polkit-1-auth-agent,
          procps,
          python3:any,
+         qml6-module-qtcore,
          qml6-module-qt-labs-platform,
          qml6-module-qt-labs-settings,
          qml6-module-qtquick-effects,
@@ -84,7 +84,7 @@
          qml6-module-qtquick-window,
          ${misc:Depends},
          ${shlibs:Depends}
-Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Recommends: qt6-wayland
 Description: Easy, fast, and secure VPN service from riseup.net
  Riseup offers Personal VPN service for censorship circumvention,

## riseup-vpn 0.25.8+ds2

=== tests/ciphersuites/Makefile ===
GW_HORNERO=212.129.4.141
OK="Peer Connection Initiated"
SLEEP_AND_KILL=sleep 3 && sudo pkill openvpn &

certs:
	/usr/bin/curl -k https://black.riseup.net/ca.crt > /tmp/ca.crt
	/usr/bin/curl -k https://api.black.riseup.net/3/cert > /tmp/cert.pem

test-hornero:
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-128-CBC PORT=53 PROTO=tcp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=53 PROTO=tcp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-128-CBC PORT=80 PROTO=udp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=80 PROTO=udp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-128-CBC PORT=1194 PROTO=tcp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-128-CBC PORT=1194 PROTO=udp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=1194 PROTO=tcp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=1194 PROTO=udp4 ./vpn-connect.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=1194 TLS=DHE-RSA-AES128-SHA PROTO=tcp4 ./vpn-connect-tls.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=1194 TLS=DHE-RSA-AES128-SHA PROTO=udp4 ./vpn-connect-tls.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=1194 TLS=TLS-ECDHE-ECDSA-WITH-AES-256-GCM-SHA384 PROTO=tcp4 ./vpn-connect-tls.sh | grep --color ${OK}
	${SLEEP_AND_KILL}
	GW=${GW_HORNERO} CIPHER=AES-256-GCM PORT=1194 TLS=TLS-ECDHE-ECDSA-WITH-AES-256-GCM-SHA384 PROTO=udp4 ./vpn-connect-tls.sh | grep --color ${OK}

=== debian/changelog ===
riseup-vpn (0.25.8+ds2-2~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Nilesh Patra <nilesh@debian.org>  Mon, 15 Sep 2025 03:39:41 +0530

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: riseup-vpn
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Nilesh Patra <nilesh@debian.org>
 Section: net
 Testsuite: autopkgtest-pkg-go
@@ -28,7 +27,6 @@
                golang-github-pkg-errors-dev,
                golang-github-prometheus-community-pro-bing-dev,
                golang-github-protonmail-go-autostart-dev,
-               golang-refraction-networking-utls-dev,
                golang-github-rakyll-statik-dev,
                golang-github-rs-zerolog-dev (>= 1.29.1-1~),
                golang-github-sevlyar-go-daemon-dev,
@@ -45,6 +43,7 @@
                golang-golang-x-tools-dev,
                golang-golang-x-xerrors-dev,
                golang-goptlib-dev,
+               golang-snowflake-dev,
                libqt6quickcontrols2-6,
                qmake6,
                qt6-base-dev,
@@ -58,6 +57,7 @@
 Vcs-Browser: https://salsa.debian.org/go-team/packages/riseup-vpn
 Vcs-Git: https://salsa.debian.org/go-team/packages/riseup-vpn.git
 Homepage: https://0xacab.org/leap/bitmask-vpn
+Rules-Requires-Root: no
 XS-Go-Import-Path: 0xacab.org/leap/bitmask-vpn
 
 Package: riseup-vpn
@@ -68,7 +68,7 @@
          libqt6svg6,
          openvpn,
          pkexec,
-         lxpolkit | lxqt-policykit | mate-polkit | polkit-kde-agent-1 | policykit-1-gnome | polkit-1-auth-agent,
+         policykit-1-gnome | polkit-1-auth-agent,
          procps,
          python3:any,
          qml6-module-qtcore,

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	cd $(BUILDDIR) && $(MAKE) gen_providers_json PROVIDER=riseup,riseupbeta && $(MAKE) build VERSION=$(VERSION) LRELEASE=/usr/lib/qt6/bin/lrelease QMAKE=/usr/bin/qmake6 PROVIDER=riseup TARGET=riseup-vpn
 
 override_dh_auto_test:
+ifneq (riscv64,$(DEB_HOST_ARCH))
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Qmake test
 	cd $(BUILDDIR) && qmake6 test.pro -o tests/Makefile.test && \
@@ -30,6 +31,7 @@
 	# Golang test
 	DH_GOLANG_EXCLUDES=gui dh_auto_test
 endif
+endif
 
 override_dh_auto_install:
 	dh_auto_install -- --no-source

## riseup-vpn 0.25.8+ds3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(bitmask VERSION 1.0 LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(QT NAMES Qt5 Qt6 REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Qml Quick QuickControls2 Svg Widgets LinguistTools)

find_library(LIB_TO_INCLUDE goshim lib)
#qt_standard_project_setup()
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

qt_add_executable(bitmask WIN32 MACOSX_BUNDLE
    gui/handlers.cpp gui/handlers.h
    gui/main.cpp
    gui/qjsonmodel.cpp gui/qjsonmodel.h
    lib/libgoshim.h
)
qt_add_qml_module(bitmask
    URI bitmask
    VERSION ${PROJECT_VERSION}
    QML_FILES
        gui/main.qml
        gui/themes/themes.js
        gui/themes/theme-riseup.js
        gui/themes/Riseup.qml
        gui/themes/theme-calyx.js
        gui/themes/Calyx.qml
        gui/themes/ThemeObject.qml
        gui/components/MainView.qml
        gui/components/ThemedPage.qml
        gui/components/Splash.qml
        gui/components/FadeBehavior.qml
        gui/components/Home.qml
        gui/components/Header.qml
        gui/components/Footer.qml
        gui/components/About.qml
        gui/components/MaterialRadioButton.qml
        gui/components/MaterialRadioIndicator.qml
        gui/components/WrappedRadioButton.qml
        gui/components/MaterialCheckBox.qml
        gui/components/StatusBox.qml
        gui/components/Systray.qml
        gui/components/Help.qml
        gui/components/Locations.qml
        gui/components/SignalIcon.qml
        gui/components/Preferences.qml
        gui/components/BoldLabel.qml
        gui/components/LightLabel.qml
        gui/components/VPNButtonBase.qml
        gui/components/VPNMouseArea.qml
        gui/components/VerticalSpacer.qml
        gui/components/Icon.qml
        gui/components/MaterialButton.qml
        gui/components/VPNState.qml
        gui/components/InitErrors.qml
        gui/components/ErrorBox.qml
        gui/components/MotdBox.qml
        gui/components/NavigationDrawer.qml
    RESOURCES
        gui/qtquickcontrols2.conf
        gui/resources/icon-noshield.svg
        gui/resources/location.svg
        gui/resources/settings.svg
        gui/resources/power.svg
        gui/resources/language.svg
        gui/resources/lightning.svg
        gui/resources/close.svg
        gui/resources/donate.svg
        gui/resources/tools.svg
        gui/resources/help.svg
        gui/resources/about.svg
        gui/resources/bridge.svg
        gui/resources/gear-fill.svg
        gui/resources/reception-0.svg
        gui/resources/reception-2.svg
        gui/resources/reception-4.svg
        gui/resources/reception-0@24.svg
        gui/resources/reception-4@24.svg
        gui/resources/arrow-left.svg
        gui/resources/globe.svg
        gui/resources/spy.gif
        gui/resources/quit.svg
        gui/resources/alert.svg
        gui/resources/angle-right.svg
        gui/resources/snowflake.svg
        gui/resources/ravens.svg
        gui/resources/ravens.gif
        gui/resources/riseup-icon.svg
        gui/resources/calyx/calyx-shield-green.png
        gui/resources/calyx/calyx-hand.png
        gui/resources/calyx/calyx-red-shield.png
        gui/resources/calyx/calyx-yellow-shield.png
        gui/resources/fonts/Poppins-Regular.ttf
        gui/resources/fonts/Poppins-Bold.ttf
        gui/resources/fonts/Montserrat-SemiBold.ttf
        gui/resources/fonts/Roboto-Regular.ttf
        gui/resources/fonts/Roboto-Bold.ttf
        gui/assets/icon/png/black/vpn_off.png
        gui/assets/icon/png/black/vpn_on.png
        gui/assets/icon/png/black/vpn_wait_0.png
        gui/assets/icon/png/black/vpn_wait_1.png
        gui/assets/icon/png/black/vpn_wait_2.png
        gui/assets/icon/png/black/vpn_wait_3.png
        gui/assets/icon/png/white/vpn_off.png
        gui/assets/icon/png/white/vpn_on.png
        gui/assets/icon/png/white/vpn_wait_0.png
        gui/assets/icon/png/white/vpn_wait_1.png
        gui/assets/icon/png/white/vpn_wait_2.png
        gui/assets/icon/png/white/vpn_wait_3.png
        gui/assets/img/bird.jpg
        gui/providers/providers.json
    NO_RESOURCE_TARGET_PATH
    OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/release
)
set_source_files_properties("gui/providers/providers.json"
    PROPERTIES QT_RESOURCE_ALIAS "providers.json"
)
set_source_files_properties("gui/resources/fonts/Montserrat-SemiBold.ttf"
    PROPERTIES QT_RESOURCE_ALIAS "monserrat-bold.ttf"
)
set_source_files_properties("gui/resources/fonts/Poppins-Bold.ttf"
    PROPERTIES QT_RESOURCE_ALIAS "poppins-bold.ttf"
)
set_source_files_properties("gui/resources/fonts/Poppins-Regular.ttf"
    PROPERTIES QT_RESOURCE_ALIAS "poppins-regular.ttf"
)
set_source_files_properties("gui/resources/fonts/Roboto-Bold.ttf"
    PROPERTIES QT_RESOURCE_ALIAS "roboto-bold.ttf"
)
set_source_files_properties("gui/resources/fonts/Roboto-Regular.ttf"
    PROPERTIES QT_RESOURCE_ALIAS "roboto.ttf"
)

# Avoid collision between executable name and QML module directory (QTBUG-98568).
if(NOT WIN32 AND NOT APPLE)
    set_property(TARGET bitmask PROPERTY OUTPUT_NAME bitmask_app)
endif()

target_compile_definitions(bitmask PRIVATE
    QT_DEPRECATED_WARNINGS
)

target_link_libraries(bitmask PRIVATE
    # Remove: L../../lib
    Qt::Core
    Qt::Gui
    Qt::Qml
    Qt::Quick
    Qt::QuickControls2
    Qt::Svg
    Qt::Widgets
    ${LIB_TO_INCLUDE}
    pthread
)


# Resources:
set_source_files_properties("providers/riseup/assets/icon.svg"
    PROPERTIES QT_RESOURCE_ALIAS "icon.svg"
)
set(vendor_resource_files
    "providers/riseup/assets/icon.svg"
)

qt_add_resources(bitmask "vendor"
    PREFIX
        "/vendor/"
    BASE
        "providers/riseup"
    FILES
        ${vendor_resource_files}
)

qt_add_translations(bitmask TS_FILES
    gui/i18n/base.ts
    gui/i18n/main_de.ts
    gui/i18n/main_el.ts
    gui/i18n/main_es_ES.ts
    gui/i18n/main_es-rAR.ts
    gui/i18n/main_es.ts
    gui/i18n/main_et.ts
    gui/i18n/main_fa_IR.ts
    gui/i18n/main_fi.ts
    gui/i18n/main_fr.ts
    gui/i18n/main_hu.ts
    gui/i18n/main_it.ts
    gui/i18n/main_lt.ts
    gui/i18n/main_nl.ts
    gui/i18n/main_pl.ts
    gui/i18n/main_pt-rBR.ts
    gui/i18n/main_ru.ts
    gui/i18n/main_th.ts
    gui/i18n/main_tr.ts
    gui/i18n/main_ug.ts
    gui/i18n/main_zh-rTW.ts
    gui/i18n/main_zh.ts
)

if(MACOS)
    target_link_libraries(bitmask PRIVATE
        "-framework CoreFoundation"
        "-framework Security"
    )
endif()

install(TARGETS bitmask
    BUNDLE DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

qt_generate_deploy_qml_app_script(
    TARGET bitmask
    FILENAME_VARIABLE deploy_script
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
    MACOS_BUNDLE_POST_BUILD
)
install(SCRIPT ${deploy_script})

=== docker/Makefile ===
#########################################################################
# Docker build environment for BitmaskVPN
# (c) LEAP Encryption Access Project, 2019-2020
#########################################################################

IMAGE=bitmask-vpn
REGISTRY=registry.0xacab.org/leap

PROVIDER=riseup
PRODUCT=$(shell echo $(PROVIDER) | sed -e "s/\b\(.\)/\u\1/g")VPN

UNINSTALLER_NSIS="../deploy/produce-bitmask-uninstaller.exe"
UNINSTALLER_WINE=".wine/drive_c/bitmask-uninstall.exe"
UNINSTALLER_STAGING="../build/windows/staging/uninstall.exe"
UNINSTALLER_SIGNED="../build/windows/staging/uninstall-signed.exe"
SIGNCODE=osslsigncode
SECRETS="leap/secrets/windoze"

build: 
	mkdir -p mods && cp ../go.mod ../go.sum mods/ && cp -r ../packages mods/
	docker build -t $(REGISTRY)/$(IMAGE):latest .
deps:
	sudo apt install osslsigncode
push:
	docker push $(REGISTRY)/$(IMAGE):latest
prune:
	docker system prune
login:
	docker login $(REGISTRY)

package_snap:
	docker run \
	    -e PROVIDER=$(PROVIDER) \
	    -e TYPE=snap \
	    -v `python3 -c 'import os; print(os.path.abspath(".."))'`:/bitmask-vpn.host \
	    --cpus="4" \
	    -it --rm \
	    $(REGISTRY)/$(IMAGE):latest  \
	    /builder.sh


package_win: clean_win package_win_stage_1 sign_win_uninstaller_in_host package_win_stage_2 sign_win_installer_in_host

clean_win:
	@rm -f ../deploy/*.exe

package_win_stage_1:
	docker run \
	    -e PROVIDER=$(PROVIDER) \
	    -e XBUILD=win \
	    -e STAGE=1 \
	    -v `python3 -c 'import os; print(os.path.abspath(".."))'`:/bitmask-vpn.host \
	    --cpus="4" \
	    -it --rm \
	    $(REGISTRY)/$(IMAGE):latest  \
	    /builder.sh

sign_win_uninstaller_in_host:
	@rm -f $(UNINSTALLER_STAGING)
	@rm -f $(UNINSTALLER_WINE)
	@echo "[+] running nsis uninstaller under wine..."
	@wine $(UNINSTALLER_NSIS) || echo "[+] wine finished (it exits badly)"
	@cp ~/$(UNINSTALLER_WINE) $(UNINSTALLER_STAGING) && echo "[+] copied uninstaller to staging dir:" $(UNINSTALLER_STAGING)
	@$(SIGNCODE) sign \
	    -certs ~/$(SECRETS)/win.crt \
	    -key ~/$(SECRETS)/key.pem \
	    -pass `gpg --decrypt ~/$(SECRETS)/../windoze.gpg` \
	    -n "$(PRODUCT) Uninstaller" -i "https://leap.se/" \
	    -in $(UNINSTALLER_STAGING) \
	    -out $(UNINSTALLER_SIGNED)
	@echo "[+] signed uninstaller in:" $(UNINSTALLER_SIGNED)

package_win_stage_2:
	docker run \
	    -e PROVIDER=$(PROVIDER) \
	    -e XBUILD=win \
	    -e STAGE=2 \
	    -v `python3 -c 'import os; print(os.path.abspath(".."))'`:/bitmask-vpn.host \
	    --cpus="4" \
	    -it --rm \
	    $(REGISTRY)/$(IMAGE):latest  \
	    /builder.sh

sign_win_installer_in_host:
	$(eval INSTALLER := $(shell ls -tr ../deploy/$(PRODUCT)*.exe | tail -n 1))
	$(eval INSTALLER_SIGNED := $(shell echo $(INSTALLER) | sed 's/\.exe/-signed.exe/'))
	@$(SIGNCODE) sign \
	    -certs ~/$(SECRETS)/win.crt \
	    -key ~/$(SECRETS)/key.pem \
	    -pass `gpg --decrypt ~/$(SECRETS)/../windoze.gpg` \
	    -n "$(PRODUCT) Installer" -i "https://leap.se/" \
	    -in $(INSTALLER) \
	    -out ../deploy/$(INSTALLER_SIGNED)
	@echo "[+] signed installer in:" $(INSTALLER_SIGNED)

shell:
	docker run -v `python3 -c 'import os; print(os.path.abspath(".."))'`:/bitmask-vpn.host -it --rm $(REGISTRY)/$(IMAGE):latest  /bin/bash

=== branding/templates/makefile/Makefile ===
#########################################
# (c) LEAP Encryption Access Project 2018
include vendor.mk
#########################################

#
# TODO review some of these targets, can go in the parent makefile
# 

SYSTRAY := 0xacab.org/leap/bitmask-vpn
STAGING := staging
SYSTRAY_BIN := bitmask-vpn
HELPER_BIN := bitmask_helper
BUILD_RELEASE?=no
WIN_CERT_PATH?=z:\leap\LEAP.pfx
WIN_CERT_PASS?=
OSX_CERT = "Developer ID Installer: LEAP Encryption Access Project"
DEB_VERSION = $(shell echo ${VERSION} | rev | cut -d '-' -f2- | rev)

ifeq ($(OS),Windows_NT)     # is Windows_NT on XP, 2000, 7, Vista, 10...
SYSTEM = Windows
else
SYSTEM = $(shell uname -s)
endif


# -----------------------------------------------------------------------------
# Windows 
# -----------------------------------------------------------------------------
ifeq ($(SYSTEM), Windows)
pkg_win: staging\openvpn\openvpn.exe
	echo "[+] building windows"
	copy ..\bin\bitmask-vpn staging\bitmask-vpn.exe
	copy ..\bin\bitmask-helper staging\bitmask_helper.exe
	"C:\Program Files (x86)\NSIS\makensis.exe" windows/$(APPNAME)-installer.nsi
else
pkg_win_stage_1: staging/openvpn/openvpn.exe
	echo "[+] building windows [stage1]"
	cp ../bin/windows/bitmask-vpn staging/bitmask-vpn.exe
	cp ../bin/windows/bitmask-helper-go staging/helper.exe
	touch windows/uninstall.exe
	makensis -DUNINSTALLER windows/$(APPNAME)-installer.nsi
	mv dist/produce-bitmask-uninstaller.exe ../../deploy/

pkg_win_stage_2: staging/openvpn/openvpn.exe
	echo "[+] building windows [stage2]"
	cp ../bin/windows/bitmask-vpn staging/bitmask-vpn.exe
	cp ../bin/windows/bitmask-helper-go staging/helper.exe
	cp ../windows/staging/uninstall-signed.exe windows/uninstall.exe
	makensis windows/$(APPNAME)-installer.nsi
	mv dist/$(APPNAME)-$(VERSION).exe ../../deploy/
endif

sign_win:
	echo "[+] signing windows build"
	python windows/sign.py $(WIN_CERT_PATH) $(WIN_CERT_PASS)

# -----------------------------------------------------------------------------
# OSX
# -----------------------------------------------------------------------------

pkg_osx:
	echo "[+] Building osx package..."
	cp ../bin/darwin/bitmask-vpn dist/$(APPNAME).app/Contents/MacOS/
	cp ../bin/darwin/bitmask-helper dist/$(APPNAME).app/Contents/MacOS/
	cp $(STAGING)/openvpn-osx dist/$(APPNAME).app/Contents/Resources/openvpn.leap
	chmod +x dist/$(APPNAME).app/Contents/Resources/openvpn.leap
ifeq ($(SYSTEM), Darwin)
	osx/quickpkg --output dist/$(APPNAME)-$(VERSION)_unsigned.pkg --scripts osx/scripts/ dist/$(APPNAME).app/
	@if [ $(BUILD_RELEASE) = no ]; then\
		echo "[!] BUILD_RELEASE=no, skipping signature";\
	else\
		echo "[+] Signing the bundle";\
		productsign --sign $(OSX_CERT) dist/$(APPNAME)-$(VERSION)_unsigned.pkg dist/$(APPNAME)-$(VERSION).pkg;\
	fi
else
	cd osx && APPNAME=$(APPNAME) VERSION=$(VERSION) ./cross-quickpkg
endif
	mv dist/$(APPNAME)-$(VERSION)*.pkg ../../deploy/

# -----------------------------------------------------------------------------
# Linux 
# -----------------------------------------------------------------------------

pkg_snap:
	-@mkdir -p ../../deploy
	@echo "[+] building snap..."
	cd ../..; \
	snapcraft build; \
	snapcraft snap
	-@rm ../../snap
	@mv ../../$(BINNAME)* ../../deploy

prepare_deb:
	echo "[+] building debian package version" ${DEB_VERSION}
	-@mkdir -p ../../deploy
	@if [ $(BUILD_RELEASE) = no ]; then\
		dch -v $(VERSION) -M "debian package generated from the git repository" && echo "[!] BUILD_RELEASE=no, incrementing changelog";\
	else\
		echo "[!] BUILD_RELEASE";\
	fi
	@mkdir -p build 
	# bitmask-vpn tar.gz should be placed in parent forlder after doing 'make prepare' with the
	# bitmask-vpn topmost Makefile.
	@cp ../bitmask-vpn_$(VERSION).tgz build/$(BINNAME)_${DEB_VERSION}.orig.tar.gz
	@rm -rf build/${BINNAME}_${DEB_VERSION} build/bitmask-vpn_${VERSION}-src
	@cd build && tar xzf $(BINNAME)_${DEB_VERSION}.orig.tar.gz && mv bitmask-vpn_${VERSION}-src ${BINNAME}_${DEB_VERSION}
	@cp -r debian/ build/$(BINNAME)_$(DEB_VERSION)/

pkg_deb: prepare_deb
	@cd build/$(BINNAME)_$(DEB_VERSION) && debuild -us -uc
	@mv build/*.deb ../../deploy

# -----------------------------------------------------------------------------
# Utils
# -----------------------------------------------------------------------------

clean:
	rm -rf dist/ build/

staging\openvpn\openvpn.exe:
	if not exist staging\openvpn mkdir staging\openvpn
	wget https://build.openvpn.net/downloads/releases/latest/tap-windows-latest-stable.exe -O staging/openvpn/tap-windows.exe
# eventually, this should be built statically and cross compiled in the same pipeline that we build the installer. 
	wget https://downloads.leap.se/thirdparty/windows/openvpn-x86_64-w64-mingw32.tar.bz2 -O staging/openvpn/openvpn.tar.bz2
	7z e -y -ostaging/openvpn/ staging/openvpn/openvpn.tar.bz2
	7z e -y -r -ostaging/openvpn/ staging/openvpn/openvpn.tar *.dll
	7z e -y -r -ostaging/openvpn/ staging/openvpn/openvpn.tar *.exe
	copy .\staging\openvpn\openvpn.exe .\staging
	copy .\staging\openvpn\*.dll .\staging
staging/openvpn/openvpn.exe:
	@mkdir -p staging/openvpn
	wget https://build.openvpn.net/downloads/releases/latest/tap-windows-latest-stable.exe -O $(STAGING)/openvpn/tap-windows.exe
	wget https://downloads.leap.se/thirdparty/windows/openvpn-x86_64-w64-mingw32.tar.bz2 -O $(STAGING)/openvpn/openvpn.tar.bz2
	@tar xjf $(STAGING)/openvpn/openvpn.tar.bz2 -C $(STAGING)/openvpn/
	cp $(STAGING)/openvpn/bin/openvpn.exe $(STAGING)/openvpn
	cp $(STAGING)/openvpn/bin/*.dll $(STAGING)
	cp $(STAGING)/openvpn/lib/engines-1_1/*.dll $(STAGING)

=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
                golang-github-pkg-errors-dev,
                golang-github-prometheus-community-pro-bing-dev,
                golang-github-protonmail-go-autostart-dev,
+               golang-refraction-networking-utls-dev,
                golang-github-rakyll-statik-dev,
                golang-github-rs-zerolog-dev (>= 1.29.1-1~),
                golang-github-sevlyar-go-daemon-dev,
@@ -43,7 +44,6 @@
                golang-golang-x-tools-dev,
                golang-golang-x-xerrors-dev,
                golang-goptlib-dev,
-               golang-snowflake-dev,
                libqt6quickcontrols2-6,
                qmake6,
                qt6-base-dev,
@@ -68,7 +68,7 @@
          libqt6svg6,
          openvpn,
          pkexec,
-         policykit-1-gnome | polkit-1-auth-agent,
+         lxpolkit | lxqt-policykit | mate-polkit | polkit-kde-agent-1 | policykit-1-gnome | polkit-1-auth-agent,
          procps,
          python3:any,
          qml6-module-qtcore,

=== debian/watch ===
Version: 5

Template: Gitlab
Dist: https://0xacab.org/leap/bitmask-vpn
Repack: yes
Compression: xz
Repacksuffix: +ds1
Dversion-Mangle: auto
